Doomsday Engine - Feature #1600

Drop Snowberry
2013-10-18 13:27 - skyjake

Status: Closed Start date: 2014-04-19
Priority: Normal % Done: 100%
Assignee: Deng Team

Category: Cleanup

Target version: 2.0 — Home Ul & Packages

Description

Doomsday should not need a separate launcher once the Home screen (Ring Zero GUI) has been improved enough to support

addons and resource configuration.

See: proposal
Subtasks:
Feature # 1684: Launching without Snowberry Closed
Feature # 2020: Remove Snowberry from distribution packages Closed
Related issues:
Related to Feature #1887: Migrate project build system to CMake 3 Closed 2014-10-20
Related to Bug #2003: Windows uninstaller leaves compiled Python files behind Closed 2015-03-26
Related to Feature #4: Ul improvements In Progress  2003-06-17
Related to Feature #2072: Gracefully exit to Home on fatal error in a game (e... New 2015-05-27
Related to Feature #2092: [Unix] Add .desktop files for apps in the installation Closed 2015-06-15
Related to Feature #2047: Allow user to select a specific IWAD file for a (cu... Closed 2015-05-13
Follows Feature #1601: Package management In Progress  2014-04-18
Precedes Feature #2016: "Portable app" package (app contained in a folder, wi... Closed 2014-10-21
Associated revisions
Revision bfbce9b3 - 2017-03-14 17:32 - skyjake
Snowberry: Moved Snowberry to the attic
Omitted from source packages.
IssuelD #1600
Revision 8a86da4c - 2017-03-14 22:08 - skyjake
Snowberry: Moved Snowberry to the attic
Omitted from source packages.
IssuelD #1600
History
#1 - 2013-10-18 13:27 - skyjake
- Description updated
#2 - 2013-10-18 13:28 - skyjake
- Target version set to 2.0 — Home Ul & Packages
#3 - 2013-10-18 14:42 - skyjake
- Category set to Redesign
#4 - 2013-10-22 09:00 - skyjake
- Status changed from New to In Progress
#5 - 2013-11-11 10:52 - skyjake

- Description updated

#6 - 2013-11-11 10:53 - skyjake

- Description updated

In practice, it is quite a lot of work to replicate all of Snowberry's features in Doomsday. However, every day Snowberry is growing more outdated. To
facilitate gradual transition away from Snowberry, the distribution packages should already allow one to launch Doomsday directly into Ring Zero
while retaining Snowberry as-is. This way people who have problems with Snowberry could already skip it.

#8 - 2015-03-21 22:56 - skyjake

- Description updated

#9 - 2015-03-21 23:00 - skyjake
- Related to Feature #1887: Migrate project build system to CMake 3 added

#10 - 2015-03-28 18:11 - skyjake
- Related to Bug #2003: Windows uninstaller leaves compiled Python files behind added

#11 - 2015-04-22 04:38 - danij
- Target version changed from 2.0 — Home Ul & Packages to 42

#12 - 2015-04-22 15:13 - vermil

I've been wondering if Dday should remove Snowberry from the very first 1.16 unstable build, irrespective of whether all of it's features are easily
accessible via Ring Zero or the Taskbar (all of Snowberry's features are accessible in some way by Dday or the command line)? There are some
features of Dday | wouldn't suggest doing such a thing with, but | debate that with this feature and it's 'state’, that it might be beneficial?

To give the new Ul a public testing so to speak; currently | think Snowberry means that 99.9% of users will completely bypass Ring Zero and the
Taskbar.

| have to admit that I'm not sure under which tracker issue that discussion on dropping Snowberry belongs?

#13 - 2015-04-23 02:35 - danij

Dropping Snowberry is (IMO) the single most important near-term milestone that we've yet to reach. Its not simply a case of some users having
trouble with it. Until we get rid of Snowberry the majority of users will bypass the home screen, not encounter the task bar and consequently overlook
the majority of what we've been working on over the past few years. Snowberry has now long overstayed its welcome.

The fact that several add-on formats are only understood by the front end (!) is a significant hurdle. While one can argue that Snowberry is already
unnecessary and can be skipped, this rather depends upon the add-ons you use. The average user does not understand how to repackage add-ons

like the jDRP so they can be used without Snowberry. Therefore, using Doomsday without Snowberry is not an option for some people. (Logically
speaking, Doomsday is currently dependent on Snowberry, meaning its not accurate to describe it as a "front end" as such).

#14 - 2015-04-23 12:55 - vermil
danij wrote:
The fact that several add-on formats are only understood by the front end (!) is a significant hurdle.
| fully understand where yourself is coming from with this, but | also think it needs to be noted that the only released mods, that | can think of, that
ever used these formats were the three main model packs?

These could probably easily be re-packaged as standard pk3's with additional smaller pk3's for the optional alternate models offered by a couple of
them?

| think the Snowberry specific add-on formats could be pushed way down the list of requirements (i.e | would separate supporting them from loading
standard pwads and/or pk3's and move it far far lower down the list of priorities with the Ul.

Snowberry’s predecessor Kickstart also had its own add-on format (ksa files). Neither Snowberry or Doomsday itself has ever added backward
compatibility support for that (i.e something like a decade later or so) and there has never been any issue raised by users to my knowledge.

This is because it was only used by a couple of released add-on’s in its time (as far as | am aware), one of which was the Doom model pack, which
was updated to a Snowberry add-on format, which as mentioned above, has in hindsight, been similarly underused.

The point I'm making is, consider cutting the Snowberry add-on formats completely, as an un-successful evolution and don’t worry about supporting
them in modern Dday (not to say Dday shouldn’t try a new add-on format again in future of course)?
#15 - 2015-04-23 16:28 - skyjake
vermil wrote:
I've been wondering if Dday should remove Snowberry from the very first 1.16 unstable build, irrespective of whether all of it's features are easily

accessible via Ring Zero or the Taskbar (all of Snowberry's features are accessible in some way by Dday or the command line)?

| agree with both of you that Snowberry needs to go soon. In practice the way | see this playing out is that we just remove it from the unstable builds
(of the next stable release), accept that certain addons will be temporarily unavailable (in a GUI-only usage scenario), and then start rebuilding the
required features into the engine.

Naturally we can't release a stable version without Snowberry until all the major addons are again supported. However, | don't see adding support for
the Snowberry bundles as a major obstacle -- after all, they are mostly containers for PK3s with some lightweight configuration.

#16 - 2015-04-24 19:57 - danij
- Precedes Feature #2016: "Portable app" package (app contained in a folder, with all user data included; e.g., for USB sticks) added

#17 - 2015-05-03 14:22 - skyjake
- Target version changed from 42 to 2.0 — Home Ul & Packages

#18 - 2015-05-08 05:54 - skyjake

- Related to Feature #4: Ul improvements added

#19 - 2015-05-27 20:58 - rhargrave

- Related to Feature #2072: Gracefully exit to Home on fatal error in a game (e.g., DED/resource error) added

#20 - 2015-06-15 22:27 - skyjake
- Related to Feature #2092: [Unix] Add .desktop files for apps in the installation added

#21 - 2015-11-10 11:37 - skyjake

- Related to Feature #2047: Allow user to select a specific IWAD file for a (custom) game session added

#22 - 2015-11-10 11:37 - skyjake

- Status changed from In Progress to Closed

#23 - 2017-02-25 17:50 - skyjake

- Tags changed from RingZero, Snowberry to Snowberry, Home

#24 - 2017-02-25 18:06 - skyjake

- Category changed from Redesign to Cleanup
